<script setup lang="ts">
import { nextTick, ref } from 'vue'
import { useMemberStore } from '@/stores/member'
import type { Member } from '@/types/Customer'
import type { VForm } from 'vuetify/components'

const tel = ref('')
const memberstore = useMemberStore()
const isSearching = ref(false)

const onClick = () => {
  isSearching.value = true
  memberstore.searchMember(tel.value)
}

const clear = () => {
  tel.value = '' // ลบข้อความใน text field
  isSearching.value = false // ตั้งค่า isSearching เป็น false
}
const searchQuery = ref('')

const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const members = ref<Member[]>([])
const loading = ref(false)
const initilMember: Member = {
  id: -1,
  name: '',
  tel: '',
  point: 0,
  accumulate: 0,
  discount: 0
}
let editedIndex = -1
let lastId = 5
const editedMember = ref<Member>(JSON.parse(JSON.stringify(initilMember)))

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initilMember)
  })
}

const save = async () => {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  if (editedIndex > -1) {
    Object.assign(members.value[editedIndex], editedMember.value)
  } else {
    // Increment lastPoint after assigning it to editedMember.value.point
    // editedMember.value.point = lastPoint++;
    editedMember.value.id = lastId++
    members.value.push(editedMember.value)
  }

  editedIndex = -1
  closeDialog()
}

const closeDialog = () => {
  dialog.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initilMember)
    editedIndex = -1
  })
}

const deleteItemConfirm = () => {
  members.value.splice(editedIndex, 1)
  closeDelete()
}

const editItem = (item: Member) => {
  editedIndex = members.value.indexOf(item)
  editedMember.value = Object.assign({}, item)
  dialog.value = true
}

const deleteItem = (item: Member) => {
  editedIndex = members.value.indexOf(item)
  editedMember.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}

function initialize() {
  members.value = [
    {
      id: 1,
      name: 'Mod Mod',
      tel: '0812345678',
      point: 50,
      accumulate: 60,
      discount: 10
    },
    {
      id: 2,
      name: 'Ja Ja',
      tel: '0823456789',
      point: 48,
      accumulate: 50,
      discount: 5
    },
    {
      id: 3,
      name: 'Poy Poy',
      tel: '0834567891',
      point: 29,
      accumulate: 30,
      discount: 0
    },
    {
      id: 4,
      name: 'Mild Mild',
      tel: '0845678912',
      point: 55,
      accumulate: 55,
      discount: 10
    }
  ]
}
const searchMembers = () => {
  const searchs = searchQuery.value.toLowerCase()
  if (!searchs) {
    // ถ้าไม่ได้ป้อนคำค้นหา ให้แสดงทั้งหมด
    members.value = [...members.value]
  } else {
    // กรองข้อมูลที่ตรงกับคำค้นหา
    members.value = members.value.filter(
      (member) =>
        member.name.toLowerCase().includes(searchs) ||
        member.tel.includes(searchs) ||
        String(member.point).includes(searchs) ||
        String(member.accumulate).includes(searchs) ||
        String(member.discount).includes(searchs)
    )
  }
}
const isAddMemberDialogOpen = ref(false)
const openAddMemberDialog = () => {
  isAddMemberDialogOpen.value = true
}
const closeAddMemberDialog = () => {
  isAddMemberDialogOpen.value = false
}
</script>

<template>
  <v-container>
    <v-row no-gutters>
      <v-col cols="10">
        <v-text-field
          v-model="tel"
          density="compact"
          variant="solo"
          label="Search Member"
          append-inner-icon="mdi-magnify"
          single-line
          hide-details
          @click:append-inner="onClick"
          @keyup.enter="onClick"
          :style="{ width: '100%' }"
        ></v-text-field>
      </v-col>
    </v-row>
    <div class="d-flex justify-space-around">
      <v-row
        cols="6"
        class="pa-3 text-start d-flex justify-left"
        :style="{ 'font-size': '16px', color: memberstore.currentMember ? 'white' : 'black' }"
      >
        <template v-if="memberstore.currentMember && isSearching">
          ชื่อสมาชิก: {{ memberstore.currentMember?.name }}
          <br />
          <template v-if="memberstore.currentMember?.point !== undefined">
            คะแนนสะสม: {{ memberstore.currentMember?.point }}
            <v-icon icon="md:plus" :color="memberstore.currentMember ? 'white' : 'black'"></v-icon>
          </template>
        </template>
        <template v-else-if="!isSearching"></template>
        <template v-else>
          {{ isSearching ? 'User not found' : '' }}
        </template>
      </v-row>
    </div>
  </v-container>
  <v-container>
    <v-row>
      <v-row justify="center">
        <v-col cols="12">
          <v-row>
            <td>
              <v-btn
                class="ma-2 add-member-button"
                size="small"
                prepend-icon="mdi-account-multiple-plus"
                @click="openAddMemberDialog"
              >
                Add Member
              </v-btn>
            </td>
            <td>
              <v-btn
                class="ma-2 claermem-button clear-member-button"
                size="small"
                prepend-icon="mdi-account-convert"
                @click="clear"
              >
                Clear Search
              </v-btn>
            </td>
            <td>
              <v-btn
                class="ma-2 promotion-button promo-member-button"
                size="small"
                prepend-icon="mdi-basket"
                @click="clear"
              >
                Promotion
              </v-btn>
            </td>
            <td>
              <v-btn
                class="ma-2 deliver-button"
                size="small"
                prepend-icon="mdi-motorbike"
                @click="clear"
              >
                Order Delivery
              </v-btn>
            </td>
          </v-row>
        </v-col>
      </v-row>
    </v-row>
  </v-container>

  <v-dialog v-model="isAddMemberDialogOpen" persistent width="800">
    <v-data-table :headers="memberstore.headers" :items="members">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Member</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-text-field
            justify="center"
            v-model="searchQuery"
            append-icon="mdi-magnify"
            label="Search Member"
            single-line
            hide-details
            @input="searchMembers"
            :style="{ width: '48%' }"
            style="margin-left: 2px"
          ></v-text-field>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props">New Member</v-btn>
            </template>
            <v-card>
              <v-card-title style="margin-top: 10px; margin-left: 20px">
                <span class="text-h5">Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMember.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Point"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Close</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Delete?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeAddMemberDialog"
                  >Cancel</v-btn
                >
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">Yes</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
        <v-btn
          icon
          color="pink"
          @click="closeAddMemberDialog"
          style="position: absolute; bottom: 2px; left: 5px"
        >
          <v-icon>mdi-close-box-outline</v-icon>
        </v-btn>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)">mdi-pencil</v-icon>
        <v-icon size="small" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize">Show Member</v-btn>
      </template>
    </v-data-table>
  </v-dialog>
</template>
<style scoped>
.promotion-button {
  background-color: #ff9800; /* เปลี่ยนสี */
  color: #ffffff; /* เปลี่ยนสีตัวอักษร */
}
.claermem-button {
  background-color: red;
  color: #ffffff;
}
.deliver-button {
  background-color: #80deea;
  color: #ffffff;
}
.add-member-button {
  font-size: 13px; /* เปลี่ยนขนาด */
  padding: 5px 12px;
}
.clear-member-button {
  font-size: 13px;
  padding: 5px 12px;
}
.promo-member-button {
  font-size: 13px;
  padding: 5px 12px;
}
</style>
